var imgAltAttrShowClassName = "twd-display-alt-attr";

// Removes all matching elements from a document
function imgAltAttrShowRemoveMatchingElements(selector, contentDocument) {
    var matchingElement = null;
    var matchingElements = contentDocument.querySelectorAll(selector);
    // go through the matching elements
    for (var i = 0, l = matchingElements.length; i < l; i++) {
        matchingElement = matchingElements[i];
        // check if the matching element has a parent node
        if (matchingElement.parentNode) {
            matchingElement.parentNode.removeChild(matchingElement);
        }
    }
}

//
//  shows alt attributes for all images
//
// eslint-disable-next-line no-unused-vars
function imgAltAttrShow() {
    var image = null;
    var images = null;
    var spanElement = null;
    var text = null;

    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        images = contentDocument.querySelectorAll("img[alt], input[type=image][alt]");
        // go through the images
        for (var index2 = 0, len2 = images.length; index2 < len2; index2++) {
            image = images[index2];
            spanElement = window.document.createElement("span");
            text = "alt=\"" + image.getAttribute("alt") + "\"";
            spanElement.setAttribute("class", imgAltAttrShowClassName);
            spanElement.appendChild(window.document.createTextNode(text));
            image.parentNode.insertBefore(spanElement, image);
        }
    }
}

//
//  undo showing alt attributes for all images
//
// eslint-disable-next-line no-unused-vars
function imgAltAttrShowUndo() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        imgAltAttrShowRemoveMatchingElements("." + imgAltAttrShowClassName, contentDocument);
    }
}