var twdOriginalHeightAttrName = "data-twd-original-height";
var twdOriginalWidthAttrName = "data-twd-original-width";

//
//  Makes all images full size
//
// eslint-disable-next-line no-unused-vars
function makeImgFullSize() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    // var alteredImages = 0;
    var element = null;
    var elementList = null;
    var naturalHeight = null;
    var naturalWidth = null;
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        elementList = docList[index1].querySelectorAll("img");
        // go through the elementList
        for (var index2 = 0, len2 = elementList.length; index2 < len2; index2++) {
            element = elementList[index2];
            naturalHeight = element.naturalHeight;
            naturalWidth = element.naturalWidth;
            // check if the height or width is not the full size
            if (naturalHeight && element.height != naturalHeight || naturalWidth && element.width != naturalWidth) {
                // store element original height and width in attributes
                element.setAttribute(twdOriginalHeightAttrName, element.height);
                element.setAttribute(twdOriginalWidthAttrName, element.width);
                element.height = element.naturalHeight;
                element.width = element.naturalWidth;
                // alteredImages++;
            }
        }
    }
}

//
//  Undo making all images full size
//
// eslint-disable-next-line no-unused-vars
function makeImgFullSizeUndo() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    // var alteredImages = 0;
    var element = null;
    var elementList = null;
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        elementList = docList[index1].querySelectorAll("img");
        for (var index2 = 0, len2 = elementList.length; index2 < len2; index2++) {
            element = elementList[index2];
            // get attr values
            var attrOriginalHeight = element.getAttribute(twdOriginalHeightAttrName);
            var attrOriginalWidth = element.getAttribute(twdOriginalWidthAttrName);
            if (attrOriginalHeight && attrOriginalWidth) {
                element.height = parseInt(attrOriginalHeight);
                element.width = parseInt(attrOriginalWidth);
                element.removeAttribute(attrOriginalWidth);
                element.removeAttribute(attrOriginalHeight);
                // alteredImages++;
            }
        }
    }
}