// for storing src attribute value
var makeImgInvisibleSrcAttrName = "twd-make-img-invisible-attr-src";
// for storing srcset attribute value
var makeImgInvisibleSrcSetAttrName = "twd-make-img-invisible-attr-srcset";
// path to transparent image
var makeImgInvisibleTransparentImg = "/img/hide_img/transparent.png";

//
//  Makes all images invisible
//
// eslint-disable-next-line no-unused-vars
function makeImgInvisible() {
    // eslint-disable-next-line no-undef
    var documents = generateDocumentList();
    var contentDocument = null;
    var image = null;
    var imageInput = null;
    var imageInputs = null;
    var images = null;
    // go through the documents
    for (var index1 = 0, len1 = documents.length; index1 < len1; index1++) {
        contentDocument = documents[index1];
        imageInputs = contentDocument.querySelectorAll("input[type=image], input[" + makeImgInvisibleSrcAttrName + "]");
        images = contentDocument.querySelectorAll("img");
        // go through the image input tags
        for (var index2 = 0, len2 = imageInputs.length; index2 < len2; index2++) {
            imageInput = imageInputs[index2];
            // check if making images invisible
            imageInput.setAttribute(makeImgInvisibleSrcAttrName, true);
            imageInput.setAttribute("type", "submit");
        }
        // go through the images
        for (index2 = 0, len2 = images.length; index2 < len2; index2++) {
            image = images[index2];

            // var widthSet=image.hasAttribute("width");
            // var widthSet=image.hasAttribute("width");
            //
            // // check if making images invisible
            // // check if the image width and height is not set and the image is not broken
            // check if (!image.hasAttribute("width") && !image.hasAttribute("height") && image.naturalWidth) {
            //     image.setAttribute("width", image.naturalWidth);
            //     // check if the image height and width is not set and the image is not broken
            // }else if(!image.hasAttribute("height") && !image.hasAttribute("width") && image.naturalHeight){
            //     image.setAttribute("height", image.naturalHeight);
            // }
            var srcAttr = image.getAttribute("src");
            if (srcAttr) {
                image.setAttribute(makeImgInvisibleSrcAttrName, srcAttr);
            }
            var srcSetAttr = image.getAttribute("srcset");
            if (srcSetAttr) {
                image.setAttribute(makeImgInvisibleSrcSetAttrName, srcSetAttr);
            }
            image.setAttribute("src", chrome.extension.getURL(makeImgInvisibleTransparentImg));
            // remove src set attribute name
            image.removeAttribute("srcset");

        }
    }
}

//
//  for making images visible
//
// eslint-disable-next-line no-unused-vars
function makeImgInvisibleUndo() {
    // eslint-disable-next-line no-undef
    var documents = generateDocumentList();
    var contentDocument = null;
    var image = null;
    var imageInput = null;
    var imageInputs = null;
    var images = null;

    // go through the documents
    for (var i = 0, l = documents.length; i < l; i++) {
        contentDocument = documents[i];
        imageInputs = contentDocument.querySelectorAll("input[type=image], input[" + makeImgInvisibleSrcAttrName + "]");
        images = contentDocument.querySelectorAll("img");

        // go through the image input tags
        for (var j = 0, m = imageInputs.length; j < m; j++) {
            imageInput = imageInputs[j];
            // check if making images visible
            if (imageInput.hasAttribute(makeImgInvisibleSrcAttrName)) {
                imageInput.removeAttribute(makeImgInvisibleSrcAttrName);
                imageInput.setAttribute("type", "image");
            }
        }
        // go through the images
        for (j = 0, m = images.length; j < m; j++) {
            image = images[j];
            // check if making images visible
            var srcAttr = image.getAttribute(makeImgInvisibleSrcAttrName);
            if (srcAttr && srcAttr != "") {
                image.setAttribute("src", srcAttr);
            }
            var srcSetAttr = image.getAttribute(makeImgInvisibleSrcSetAttrName);
            if (srcSetAttr && srcSetAttr != "") {
                image.setAttribute("srcset", srcSetAttr);
            }
            image.removeAttribute(makeImgInvisibleSrcAttrName);
            image.removeAttribute(makeImgInvisibleSrcSetAttrName);
        }
    }
}