var showImgPathClassName = "twd-display-img-path";

// Removes all matching elements from a document
function showImgPathRemoveMatchingElement(selector, contentDocument) {
    var matchingElement = null;
    var matchingElements = contentDocument.querySelectorAll(selector);
    // go through the matching elements
    for (var i = 0, l = matchingElements.length; i < l; i++) {
        matchingElement = matchingElements[i];
        // check if the matching element has a parent node
        if (matchingElement.parentNode) {
            matchingElement.parentNode.removeChild(matchingElement);
        }
    }
}

//
//  displays the paths for all images
//
// eslint-disable-next-line no-unused-vars
function showImgPath() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    var element = null;
    var elementList = null;
    var imageSrc = null;
    var anchorElem = null;
    var spanElement = null;
    // go through the docList
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        // check if displaying the alt attributes
        elementList = contentDocument.querySelectorAll("img");
        // go through the elementList
        for (var j = 0, m = elementList.length; j < m; j++) {
            element = elementList[j];
            imageSrc = element.src;
            anchorElem = window.document.createElement("a");
            anchorElem.setAttribute("target", "_blank");
            spanElement = window.document.createElement("span");

            anchorElem.setAttribute("href", imageSrc);
            anchorElem.appendChild(window.document.createTextNode("src=\"" + imageSrc + "\""));
            spanElement.setAttribute("class", showImgPathClassName);
            spanElement.appendChild(anchorElem);
            element.parentNode.insertBefore(spanElement, element);
        }
    }
}

//
//  hides image paths for all images
//
// eslint-disable-next-line no-unused-vars
function showImgPathUndo() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        showImgPathRemoveMatchingElement("." + showImgPathClassName, contentDocument);
    }
}