var replaceImgWithAltAttrClassName = "twd-replace-img-with-alt-attr";

// Removes all matching elements from a document
function replaceImgWithAltAttrRemoveMatchingElement(selector, contentDocument) {
    var matchingElement = null;
    var matchingElements = contentDocument.querySelectorAll(selector);
    // go through the matching elements
    for (var i = 0, l = matchingElements.length; i < l; i++) {
        matchingElement = matchingElements[i];
        // check if the matching element has a parent node
        if (matchingElement.parentNode) {
            matchingElement.parentNode.removeChild(matchingElement);
        }
    }
}

//
//  Replaces all images with alt attributes
//
// eslint-disable-next-line no-unused-vars
function replaceImgWithAltAttr() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    var image = null;
    var images = null;
    var spanElement = null;
    var text = null;
    // go through the docList
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        images = contentDocument.querySelectorAll("img");
        // go through the images
        for (var index2 = 0, len2 = images.length; index2 < len2; index2++) {
            image = images[index2];
            spanElement = contentDocument.createElement("span");
            text = image.getAttribute("alt");
            // check if the text is not set
            if (!text) {
                text = "";
            }
            spanElement.setAttribute("class", replaceImgWithAltAttrClassName);
            spanElement.appendChild(contentDocument.createTextNode(text));
            image.parentNode.insertBefore(spanElement, image);
        }
    }
}

//
//  Replaces all images with alt attributes
//
// eslint-disable-next-line no-unused-vars
function replaceImgWithAltAttrUndo() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    // go through the docList
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        replaceImgWithAltAttrRemoveMatchingElement("." + replaceImgWithAltAttrClassName, contentDocument);
    }
}