// Filter for the hidden node tree walker
function isElementHidden(element) {
    if (element) {
        var computedStyle = element.ownerDocument.defaultView.getComputedStyle(element, null);
        // check if the computed style is set
        if (computedStyle) {
            // eslint-disable-next-line no-undef
            var display = getCSSPropertyVal(computedStyle, "display");
            var tagName = element.tagName;
            // check if this element has a display and tag name, is not a script or style and the display is set to none
            // eslint-disable-next-line no-undef
            if (display && tagName && tagName.toLowerCase() != "script" && tagName.toLowerCase() != "style" && getCSSText(display) == "none") {
                return true;
            }
        }
    }
    return false;
}

//
// Displays all hidden elements
//
// eslint-disable-next-line no-unused-vars
function displayHiddenElem() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var inputElemList = null;
    var elementList = null;
    var contentDocument = null;
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        inputElemList = contentDocument.querySelectorAll("input[type=hidden]");
        // go through the hidden elements
        for (var index2 = 0, len2 = inputElemList.length; index2 < len2; index2++) {
            inputElemList[index2].removeAttribute("type");
        }
        // all elements
        elementList = contentDocument.querySelectorAll("*");
        // go through all elements
        for (var index3 = 0, len3 = elementList.length; index3 < len3; index3++) {
            if(isElementHidden(elementList[index3])){
                elementList[index3].style.display = "";
            }
        }
    }
}