// content script for outlining images with adjusted dimension

var outlineImgAdjustedDimensionClassName = "twd-outline-img-with-adjusted-dimension";

// provides true if an element has the specified class
function outlineImgAdjustedDimensionHasClass(element, className) {
    // check if the element and class name are set
    if (element && className) {
        var classes = element.className;
        // check if the classes are on an SVG
        if (classes instanceof SVGAnimatedString) {
            classes = classes.baseVal;
        }
        classes = classes.split(" ");
        // go through the classes
        for (var i = 0, l = classes.length; i < l; i++) {
            // check if the classes match
            if (className == classes[i]) {
                return true;
            }
        }
    }
    return false;
}

// Adds a class to an element
function outlineImgAdjustedDimensionAddClass(element, className) {
    // check if the element and class name are set and the element does not already have this class
    if (element && className && !outlineImgAdjustedDimensionHasClass(element, className)) {
        // check if the classes are on an SVG
        if (element.className instanceof SVGAnimatedString) {
            element.className.baseVal = (element.className.baseVal + " " + className).trim();
        } else {
            element.className = (element.className + " " + className).trim();
        }
    }
}

//
//  functions that adds outline from floating element
//
// eslint-disable-next-line no-unused-vars
function outlineImgAdjustedDimensionAddOutline() {
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    var contentDocument = null;
    var image = null;
    var images = null;
    var naturalHeight = null;
    var naturalWidth = null;
    console.log("doclist");
    console.log(docList);
    for (var index2 = 0, len2 = docList.length; index2 < len2; index2++) {
        contentDocument = docList[index2];
        console.log("contentDocument");
        console.log(contentDocument);
        images = contentDocument.querySelectorAll("img");
        console.log("images");
        console.log(images);
        // go through the elements
        for (var index1 = 0, len1 = images.length; index1 < len1; index1++) {
            image = images[index1];
            console.log("image");
            console.log(image);
            naturalHeight = image.naturalHeight;
            naturalWidth = image.naturalWidth;
            // check if the height or width has been adjusted
            if (naturalHeight && image.height != naturalHeight || naturalWidth && image.width != naturalWidth) {
                outlineImgAdjustedDimensionAddClass(image, outlineImgAdjustedDimensionClassName);
            }
        }
    }
}

//
//  functions that removes outline from floating element
//
// eslint-disable-next-line no-unused-vars
function outlineImgAdjustedDimensionRemoveOutline() {
    // eslint-disable-next-line no-undef
    removeClassNameFromAllDocTypeElem(
        outlineImgAdjustedDimensionClassName
    );
}