// content script for outlining images with oversized dimension

var outlineImgOversizedDimensionClassName = "twd-outline-img-with-oversized-dimension";

//
//  functions that adds outline
//
// eslint-disable-next-line no-unused-vars
function outlineImgOversizedDimensionAddOutline() {
    var contentDocument = null;
    var elementList = null;
    var element = null;
    var naturalHeight = null;
    var naturalWidth = null;
    // eslint-disable-next-line no-undef
    var docList = generateDocumentList();
    for (var index1 = 0, len1 = docList.length; index1 < len1; index1++) {
        contentDocument = docList[index1];
        if (contentDocument == null) {
            continue;
        }
        elementList = contentDocument.querySelectorAll("img");
        for (var index2 = 0, len2 = elementList.length; index2 < len2; index2++) {
            if (elementList[index2] == null) {
                continue;
            }
            element = elementList[index2];
            naturalHeight = element.naturalHeight;
            naturalWidth = element.naturalWidth;
            // check if the height or width has been oversized
            if (naturalHeight && element.height > naturalHeight || naturalWidth && element.width > naturalWidth) {
                // eslint-disable-next-line no-undef
                addClass(
                    element,
                    outlineImgOversizedDimensionClassName);
            }
        }
    }
}

//
//  functions that removes outline
//
// eslint-disable-next-line no-unused-vars
function outlineImgOversizedDimensionRemoveOutline() {
    // eslint-disable-next-line no-undef
    removeClassNameFromAllDocTypeElem(
        outlineImgOversizedDimensionClassName
    );
}
